Bug 2220 - ptrace() broken with xfs filesystem
: ptrace() broken with xfs filesystem
Status: CLOSED WONTFIX
: Sisyphus
(All bugs in Sisyphus/kernel-image-std-up)
: unstable
: all Linux
: P5 blocker
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2003-02-11 17:26 by
Modified: 2005-07-13 15:45 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2003-02-11 17:26:52
С ядрами 2.4.20-alt1 (собрано gcc3.2-3.2.1-alt2), -alt2 (собрано
gcc2.96-2.96-alt3) на системе, поставленной полностью на xfs (за исключением
/boot), имеем:

$ strace -o /dev/null ls /var/empty
umovestr: Input/output error
umovestr: Input/output error
umovestr: Input/output error
umovestr: Input/output error
umovestr: Input/output error
umovestr: Input/output error
ptrace: umoven: Input/output error
ptrace: umoven: Input/output error
umovestr: Input/output error
umovestr: Input/output error
umovestr: Input/output error
umovestr: Input/output error

Кроме того, не работает gdb:

$ gdb /bin/ls
GNU gdb ALT Linux (5.1.1-alt1)
Copyright 2002 Free Software Foundation, Inc.
GDB is free software, covered by the GNU General Public License, and you are
welcome to change it and/or distribute copies of it under certain conditions.
Type \"show copying\" to see the conditions.
There is absolutely no warranty for GDB.  Type \"show warranty\" for
details.
This GDB was configured as \"i586-alt-linux\"...(no debugging symbols
found)...
(gdb) r
Starting program: /bin/ls 
warning: Cannot insert breakpoint -2:
Cannot access memory at address 0x4000a2c0

Ситуация воспроизводится и при отсутствии системных разделов на xfs при
монтировании файловой системы xfs через -o loop:

  dd if=/dev/zero of=/tmp/test.img bs=1M count=100
  mkfs.xfs /tmp/test.img
  mount -t xfs -o loop /tmp/test.img /mnt/disk
  cp /bin/ls /mnt/disk

strace -o /dev/null /mnt/disk/ls /mnt/disk, gdb /mnt/disk/ls не работают
аналогичным образом (для gdb в этом случае не работает break __libc_start_main;
run).

При попытке смотреть через gdb память процесса во втором случае видно, что
mmap-области, соответствующие файлам на xfs, нечитаемы.
---

---
------- Comment #1 From 2003-02-13 23:14:50 -------
fixed (2.4.20-alt4)
------- Comment #2 From 2003-02-13 23:14:50 -------
fixed (2.4.20-alt4)
------- Comment #3 From 2003-02-18 18:08:25 -------
мЮ ОЕПЕЯНАПЮММНЛ 2.4.20-alt4 (gcc2.96-2.96-alt3) МЮ ЯХЯРЕЛЕ Я / МЮ xfs МХВЕЦН
МЕ ХГЛЕМХКНЯЭ. яЕИВЮЯ ОНОПНАСЧ ЯРЮЫХРЭ АХМЮПМХЙ -alt5 (НУ, МЕ УНРЕКНЯЭ...) Х
ЯПЮБМЧ Я ПЕГСКЭРЮРЮЛХ КНЙЮКЭМНИ ОЕПЕЯАНПЙХ.
------- Comment #4 From 2003-02-18 18:08:25 -------
мЮ ОЕПЕЯНАПЮММНЛ 2.4.20-alt4 (gcc2.96-2.96-alt3) МЮ ЯХЯРЕЛЕ Я / МЮ xfs МХВЕЦН
МЕ ХГЛЕМХКНЯЭ. яЕИВЮЯ ОНОПНАСЧ ЯРЮЫХРЭ АХМЮПМХЙ -alt5 (НУ, МЕ УНРЕКНЯЭ...) Х
ЯПЮБМЧ Я ПЕГСКЭРЮРЮЛХ КНЙЮКЭМНИ ОЕПЕЯАНПЙХ.
------- Comment #5 From 2003-02-18 18:09:34 -------
Да, нельзя из старой мозиллы сюда по-русски писать...
------- Comment #6 From 2003-02-18 18:09:34 -------
Да, нельзя из старой мозиллы сюда по-русски писать...
------- Comment #7 From 2003-02-18 18:11:11 -------
Так вроде работает, перевожу в нормальную кодировку:

В системе с / на xfs с 2.4.20-alt4, пересобранным из src.rpm
(gcc2.96-2.96-alt3), ошибка не исчезла. Сейчас попробую скачать бинарник -alt5.
------- Comment #8 From 2003-02-18 18:11:11 -------
Так вроде работает, перевожу в нормальную кодировку:

В системе с / на xfs с 2.4.20-alt4, пересобранным из src.rpm
(gcc2.96-2.96-alt3), ошибка не исчезла. Сейчас попробую скачать бинарник -alt5.
------- Comment #9 From 2003-02-18 18:28:38 -------
2.4.20-alt5-up (бинарник взят из Сизифа) не работает с теми же симптомами :-(
------- Comment #10 From 2003-02-18 18:28:38 -------
2.4.20-alt5-up (бинарник взят из Сизифа) не работает с теми же симптомами :-(
------- Comment #11 From 2003-02-18 18:49:49 -------
У меня это не повторяется, если используется -o loop. 
Корневой раздел на xfs еще не пробовал - систему нужно переставлять.
------- Comment #12 From 2003-02-18 18:49:49 -------
У меня это не повторяется, если используется -o loop. 
Корневой раздел на xfs еще не пробовал - систему нужно переставлять.
------- Comment #13 From 2003-02-18 19:00:09 -------
В чём и проблема :-(

А если с этого раздела грузить и *.so (LD_LIBRARY_PATH=...) - так не проявляется?
------- Comment #14 From 2003-02-18 19:00:09 -------
В чём и проблема :-(

А если с этого раздела грузить и *.so (LD_LIBRARY_PATH=...) - так не проявляется?
------- Comment #15 From 2003-02-19 11:32:57 -------
Проявилась. Похоже дело еще в библиотеках. Беру таймаут до 25-ого числа на
исправление.
Тестирую:
[<a href="mailto:root@riderbook" target="_new">root@riderbook</a> aaa]# uname
-a
Linux riderbook.office.altlinux.ru 2.4.20-alt5-up #1 Sun Feb 16 16:46:13 MSK
2003 i686 unknown unknown GNU/Linux
[<a href="mailto:root@riderbook" target="_new">root@riderbook</a> aaa]#
mount|grep xfs
/tmp/test.img on /home/rider/aaa type xfs (rw,loop=/dev/loop0)
drwxr-xr-x    2 root     root           90 Feb 19 12:24 .
drwx------   16 rider    rider         896 Feb 18 19:51 ..
-rwxr-xr-x    1 root     root        68088 Feb 19 12:24 ld-linux.so.2
-rwxr-xr-x    1 root     root      1147144 Feb 19 12:23 libc.so.6
-rwxr-xr-x    1 root     root       105492 Feb 19 12:22 libpthread.so.0
-rwxr-xr-x    1 root     root        22440 Feb 19 12:23 librt.so.1
-rwxr-xr-x    1 root     root        67852 Feb 18 19:44 ls
[<a href="mailto:root@riderbook" target="_new">root@riderbook</a> aaa]#
LD_LIBRARY_PATH=. strace -o /dev/null -fF ./ls 
ptrace: umoven: Input/output error
ptrace: umoven: Input/output error
ld-linux.so.2  libc.so.6  libpthread.so.0  librt.so.1  ls
------- Comment #16 From 2003-02-19 11:32:57 -------
Проявилась. Похоже дело еще в библиотеках. Беру таймаут до 25-ого числа на
исправление.
Тестирую:
[<a href="mailto:root@riderbook" target="_new">root@riderbook</a> aaa]# uname
-a
Linux riderbook.office.altlinux.ru 2.4.20-alt5-up #1 Sun Feb 16 16:46:13 MSK
2003 i686 unknown unknown GNU/Linux
[<a href="mailto:root@riderbook" target="_new">root@riderbook</a> aaa]#
mount|grep xfs
/tmp/test.img on /home/rider/aaa type xfs (rw,loop=/dev/loop0)
drwxr-xr-x    2 root     root           90 Feb 19 12:24 .
drwx------   16 rider    rider         896 Feb 18 19:51 ..
-rwxr-xr-x    1 root     root        68088 Feb 19 12:24 ld-linux.so.2
-rwxr-xr-x    1 root     root      1147144 Feb 19 12:23 libc.so.6
-rwxr-xr-x    1 root     root       105492 Feb 19 12:22 libpthread.so.0
-rwxr-xr-x    1 root     root        22440 Feb 19 12:23 librt.so.1
-rwxr-xr-x    1 root     root        67852 Feb 18 19:44 ls
[<a href="mailto:root@riderbook" target="_new">root@riderbook</a> aaa]#
LD_LIBRARY_PATH=. strace -o /dev/null -fF ./ls 
ptrace: umoven: Input/output error
ptrace: umoven: Input/output error
ld-linux.so.2  libc.so.6  libpthread.so.0  librt.so.1  ls
------- Comment #17 From 2003-08-24 21:03:14 -------
Проявляется ли проблема на 
------- Comment #18 From 2003-08-24 21:04:00 -------
Проявляется ли проблема на kernel-image-std-up-2.4.21rel ?
------- Comment #19 From 2003-08-25 14:19:09 -------
Нет, в 2.4.21 эта проблема отсутствует (и не наблюдалась ни с текущей версией
kernel-feat-fs-xfs-1.3-alt2, ни с более старой 1.2). Однако в
kernel24-up-2.4.20-alt9 (Master 2.2 updates) эта проблема есть.
------- Comment #20 From 2003-10-24 12:34:05 -------
Свежее ядро из 2.2/updates (2.4.20-alt10-smp) проблему не исправило.
И strace и gdb сообщают аналогично 2.4.20-alt1.
------- Comment #21 From 2004-05-05 15:54:40 -------
перевешено на нынешнего мантейнера 
------- Comment #22 From 2004-05-05 16:50:50 -------
В старых ядрах исправлять это явно поздно; в последующих версиях такой проблемы
уже нет.